'use strict';
const Generator = require('yeoman-generator');
const chalk     = require('chalk');
const yosay     = require('yosay');

module.exports = class extends Generator {
  prompting(){
    // Have Yeoman greet the user.
    this.log(
      yosay(`Welcome to the stunning ${chalk.red('generator-site-map')} generator!`)
    );

    const prompts = [
      {
        type    : 'input',
        name    : 'fileName',
        message : 'Your project name',
        default : this.appname
      }
    ];

    return this.prompt(prompts).then(props =>{
      // To access props later use this.props.someAnswer;
      this.props = props;
    });
  }

  writing(){
    var filepath = this.props.fileName + '/';
    this.fs.copy(
      this.templatePath('test.js'),
      this.destinationPath(filepath + 'test.js')
    );
    this.fs.copy(
      this.templatePath('custom.js'),
      this.destinationPath(filepath + 'custom.js')
    );
  }

  install(){
    this.installDependencies({
      bower : false,
      npm   : true,
      yarn  : true
    });
  }
};
