describe('companyName 1234', function() {
  describe('from the homepage', function() {
    before(function() {
      injectScript.loadUrl('https://www.company.com/');
    });

    it('should send a pageview event', function() {
      expect(casper.events.length).to.equal(1);
      var event = casper.events[0];

      expect(event.mi_u).to.equal('12345');
      expect(event.event_type).to.equal('pageview');
      expect(event.type).to.equal(undefined);
      expect(event.id).to.equal(undefined);
      expect(event.url).to.equal(undefined);
    });
  });

  describe('from a product page', function() {
    var url = "";
    var categories = [
      "id:,url:",
      "id:,url:",
      "id:,url:"
    ].join("|");
    var meta = [
      "brand:",
      "gender:"
    ].join(",");

    beforeEach(function() {
      injectScript.loadUrl(url);
    });

    it('should send a product pageview event', function() {
      expect(casper.events.length).to.equal(1);
      var event = casper.events[0];

      expect(event.mi_u).to.equal('12345');
      expect(event.event_type).to.equal('pageview');
      expect(event.type).to.equal('product');
      expect(event.title).to.equal('');
      expect(event.id).to.equal('');
      expect(event.price).to.equal('');
      expect(event.url).to.equal(url);
      expect(decodeURIComponent(event.categories)).to.equal(categories);
      expect(decodeURIComponent(event.meta)).to.equal(meta);
    });

    it('should send a cart_add event when clicking on "Add to Car"', function() {
      casper
        .waitForSelector('')
        .thenClick('')
        .then(function() {
          expect(casper.events.length).to.equal(2);
          var event = casper.events[1];

          expect(event.mi_u).to.equal('12345');
          expect(event.event_type).to.equal('cart_add');
          expect(event.type).to.equal(undefined);
          expect(event.title).to.equal('');
          expect(event.id).to.equal('');
          expect(event.price).to.equal('');
          expect(event.url).to.equal(url);
          expect(decodeURIComponent(event.categories)).to.equal(categories);
        });
    });
  });

  describe('from a category page', function() {
    var url = "";

    before(function() {
      injectScript.loadUrl(url);
    });

    it('should send a category pageview event', function() {
      expect(casper.events.length).to.equal(1);
      var event = casper.events[0];

      expect(event.mi_u).to.equal('12345');
      expect(event.event_type).to.equal('pageview');
      expect(event.type).to.equal('category');
      expect(event.title).to.equal('');
      expect(event.id).to.equal('');
      expect(event.url).to.equal(url);
    });
  });

  describe('from a search page', function() {
    var url = "";

    before(function() {
      injectScript.loadUrl(url);
    });

    it('should send a search pageview event', function() {
      expect(casper.events.length).to.equal(1);
      var event = casper.events[0];

      expect(event.mi_u).to.equal('12345');
      expect(event.event_type).to.equal('pageview');
      expect(event.type).to.equal('search');
      expect(event.search_term).to.equal('');
      expect(event.url).to.equal(url);
    });
  });
});
